var objTxtbgfixerBrowser = {

	onload: function (ndTarget)
	{
		if (! gPrefService.prefHasUserValue('txtbgfixer.enabled'))
			gPrefService.setBoolPref('txtbgfixer.enabled', true);

		if (! gPrefService.getBoolPref('txtbgfixer.enabled') ||
			! gPrefService.getBoolPref('browser.display.use_document_colors')) return;

		ndDocument = ndTarget.originalTarget;
		ndBody = ndDocument.getElementsByTagName("body")[0]; if (ndBody==null) return;
		ndBody.style.background="";

		sTxtcolor = ndBody.getAttribute("text");
		sBgcolor = ndBody.getAttribute("bgcolor");

		if (sBgcolor && !sTxtcolor) {
			if (sBgcolor != "#000000") ndBody.setAttribute("text", "#000000");
		}
		else if (!sBgcolor && sTxtcolor) {
			if (sTxtcolor != "#FFFFFF") ndBody.setAttribute("bgcolor", "#FFFFFF");
		}
		else if (!sBgcolor && !sTxtcolor) {
			if (this.fixElementColors (ndDocument, ndBody, "body", false));
			else if (this.fixElementColors (ndDocument, ndBody, "td", false));
			else if (this.fixElementColors (ndDocument, ndBody, "p", false));
			else if (this.fixElementColors (ndDocument, ndBody, "a", false));
		}

		if (ndDocument.getElementsByTagName("form").length > 0) {
			this.fixElementColors (ndDocument, ndBody, "input", true);
			this.fixElementColors (ndDocument, ndBody, "textarea", true);
			this.fixElementColors (ndDocument, ndBody, "select", true);
			this.fixElementColors (ndDocument, ndBody, "option", true);
		}

		if (ndDocument.links.length > 0 && ndDocument.styleSheets.length > 0) {
			sLinkcolor = ndDocument.defaultView.getComputedStyle(ndDocument.links[0],'').getPropertyValue("color");

			for (i = 0; i < ndDocument.styleSheets[0].cssRules.length; ++i) {
				if (ndDocument.styleSheets[0].cssRules[i].selectorText.indexOf("a:visited") != -1) {
					if ((sVlinkcolor=ndDocument.styleSheets[0].cssRules[i].style.color) != "") {
						if (sLinkcolor == sVlinkcolor) {
							aVlinkcolorRGB = this.rgbToArray(sVlinkcolor);
							for (j = 0; j < 3; j++) {
								aVlinkcolorRGB[j] -= 51;
								if (aVlinkcolorRGB[j] < 0) aVlinkcolorRGB[j] = 0;
							}
							ndDocument.styleSheets[0].cssRules[i].style.color = this.arrayToRgb(aVlinkcolorRGB);
							break;
						}
					}
				}
			}
		}

	},

	fixElementColors: function (ndDocument, ndBody, tagname, bFixIndividualElement) {
		fixed = false;
		ndElement = ndDocument.getElementsByTagName(tagname);
		for (i = 0; i < ndElement.length; i++) {
			aTxtcolor = this.rgbToArray(ndDocument.defaultView.getComputedStyle(ndElement[i],'').getPropertyValue("color"));
			aBgcolor = this.rgbToArray(ndDocument.defaultView.getComputedStyle(ndElement[i],'').getPropertyValue("background-color"));

			if (!aTxtcolor) aTxtcolor = this.hexToArray(gPrefService.getCharPref('browser.display.foreground_color'));
			if (!aBgcolor) aBgcolor = this.hexToArray(gPrefService.getCharPref('browser.display.background_color'));

			if (this.areArrayRgbColorsSimilar(aTxtcolor, aBgcolor, 102)) {
				if (bFixIndividualElement) {
					ndElement[i].setAttribute("style", ndElement[i].getAttribute("style") +
						"; background-color: #CCCCCC; color: #000000;");
					fixed = true;
				}
				else {
					ndBody.setAttribute("text", "#000000");
					ndBody.setAttribute("bgcolor", "#FFFFFF");
					return true;
				}
			}
		}
		return fixed;
	},

	rgbToArray: function (sRGB) {
		sRGB = sRGB.replace("rgb(","").replace(")","");
		rgbArray = sRGB.split(",");
		if (rgbArray.length == 3) return rgbArray; else return null;
	},

	arrayToRgb: function (aRGB) {
		return "rgb(" + aRGB[0] + ", " + aRGB[1] + ", " + aRGB[2] + ")";
	},

	areArrayRgbColorsSimilar: function (aRGB1, aRGB2, diff) {
		if (aRGB1 && aRGB2)
			for (j = 0; j < 3; j++)
				if (Math.abs(aRGB1[j] - aRGB2[j]) > diff) return false;
		return true;
	},

	hexToArray: function (sHex) {
		if (!sHex || sHex.length != 7) return null;
		hexChar = "0123456789ABCDEF";
		sHex = sHex.substr(1).toUpperCase();
		rgbArray = new Array(0, 0, 0);
		rgbArray[0] = hexChar.indexOf(sHex[0])*16 + hexChar.indexOf(sHex[1]);
		rgbArray[1] = hexChar.indexOf(sHex[2])*16 + hexChar.indexOf(sHex[3]);
		rgbArray[2] = hexChar.indexOf(sHex[4])*16 + hexChar.indexOf(sHex[5]);
		return rgbArray;
	},


	toggle: function()
	{
		if (gPrefService.getBoolPref('txtbgfixer.enabled')) {
			gPrefService.setBoolPref('txtbgfixer.enabled', false);
			gPrefService.setBoolPref('browser.display.use_document_colors', false);
			window._content.document.location.reload();
			this.setstatustxt("Txt-Bgcolor Fixer forcing user-defined colors");
		}
		else if (gPrefService.getBoolPref('browser.display.use_document_colors')) {
			gPrefService.setBoolPref('txtbgfixer.enabled', true);
			gPrefService.setBoolPref('browser.display.use_document_colors', true);
			window._content.document.location.reload();
			this.setstatustxt("Txt-Bgcolor Fixer on");
		}
		else {
			gPrefService.setBoolPref('txtbgfixer.enabled', false);
			gPrefService.setBoolPref('browser.display.use_document_colors', true);
			window._content.document.location.reload();
			this.setstatustxt("Txt-Bgcolor Fixer off");
		}
	},

	setstatustxt: function (msg)
	{
		document.getElementById("statusbar-display").label = msg;
	}
}

function txtbgfixerLoadWindow (e) {
	objTxtbgfixerBrowser.onload (e);
}

window.addEventListener ("load", txtbgfixerLoadWindow, true);
